<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrdersTableRow ArrayType
 * @subpackage Arrays
 */
class ArrayOfOrdersTableRow extends AbstractStructArrayBase
{
    /**
     * The ordersTableRow
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrdersTableRow[]
     */
    public $ordersTableRow;
    /**
     * Constructor method for ArrayOfOrdersTableRow
     * @uses ArrayOfOrdersTableRow::setOrdersTableRow()
     * @param \StructType\OrdersTableRow[] $ordersTableRow
     */
    public function __construct(array $ordersTableRow = array())
    {
        $this
            ->setOrdersTableRow($ordersTableRow);
    }
    /**
     * Get ordersTableRow value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrdersTableRow[]|null
     */
    public function getOrdersTableRow()
    {
        return isset($this->ordersTableRow) ? $this->ordersTableRow : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrdersTableRow method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrdersTableRow method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrdersTableRowForArrayConstraintsFromSetOrdersTableRow(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrdersTableRowOrdersTableRowItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrdersTableRowOrdersTableRowItem instanceof \StructType\OrdersTableRow) {
                $invalidValues[] = is_object($arrayOfOrdersTableRowOrdersTableRowItem) ? get_class($arrayOfOrdersTableRowOrdersTableRowItem) : sprintf('%s(%s)', gettype($arrayOfOrdersTableRowOrdersTableRowItem), var_export($arrayOfOrdersTableRowOrdersTableRowItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ordersTableRow property can only contain items of type \StructType\OrdersTableRow, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ordersTableRow value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrdersTableRow[] $ordersTableRow
     * @return \ArrayType\ArrayOfOrdersTableRow
     */
    public function setOrdersTableRow(array $ordersTableRow = array())
    {
        // validation for constraint: array
        if ('' !== ($ordersTableRowArrayErrorMessage = self::validateOrdersTableRowForArrayConstraintsFromSetOrdersTableRow($ordersTableRow))) {
            throw new \InvalidArgumentException($ordersTableRowArrayErrorMessage, __LINE__);
        }
        if (is_null($ordersTableRow) || (is_array($ordersTableRow) && empty($ordersTableRow))) {
            unset($this->ordersTableRow);
        } else {
            $this->ordersTableRow = $ordersTableRow;
        }
        return $this;
    }
    /**
     * Add item to ordersTableRow value
     * @throws \InvalidArgumentException
     * @param \StructType\OrdersTableRow $item
     * @return \ArrayType\ArrayOfOrdersTableRow
     */
    public function addToOrdersTableRow(\StructType\OrdersTableRow $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrdersTableRow) {
            throw new \InvalidArgumentException(sprintf('The ordersTableRow property can only contain items of type \StructType\OrdersTableRow, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ordersTableRow[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrdersTableRow|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrdersTableRow|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrdersTableRow|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrdersTableRow|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrdersTableRow|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ordersTableRow
     */
    public function getAttributeName()
    {
        return 'ordersTableRow';
    }
}
