<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStatus ArrayType
 * @subpackage Arrays
 */
class ArrayOfStatus extends AbstractStructArrayBase
{
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Status[]
     */
    public $Status;
    /**
     * Constructor method for ArrayOfStatus
     * @uses ArrayOfStatus::setStatus()
     * @param \StructType\Status[] $status
     */
    public function __construct(array $status = array())
    {
        $this
            ->setStatus($status);
    }
    /**
     * Get Status value
     * @return \StructType\Status[]|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * This method is responsible for validating the values passed to the setStatus method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStatus method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStatusForArrayConstraintsFromSetStatus(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfStatusStatusItem) {
            // validation for constraint: itemType
            if (!$arrayOfStatusStatusItem instanceof \StructType\Status) {
                $invalidValues[] = is_object($arrayOfStatusStatusItem) ? get_class($arrayOfStatusStatusItem) : sprintf('%s(%s)', gettype($arrayOfStatusStatusItem), var_export($arrayOfStatusStatusItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Status property can only contain items of type \StructType\Status, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Status value
     * @throws \InvalidArgumentException
     * @param \StructType\Status[] $status
     * @return \ArrayType\ArrayOfStatus
     */
    public function setStatus(array $status = array())
    {
        // validation for constraint: array
        if ('' !== ($statusArrayErrorMessage = self::validateStatusForArrayConstraintsFromSetStatus($status))) {
            throw new \InvalidArgumentException($statusArrayErrorMessage, __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Add item to Status value
     * @throws \InvalidArgumentException
     * @param \StructType\Status $item
     * @return \ArrayType\ArrayOfStatus
     */
    public function addToStatus(\StructType\Status $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Status) {
            throw new \InvalidArgumentException(sprintf('The Status property can only contain items of type \StructType\Status, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Status[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Status|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Status|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Status|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Status|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Status|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Status
     */
    public function getAttributeName()
    {
        return 'Status';
    }
}
